part of navigine_sdk;

class NavigineSDK {
  static Future<NavigineSDK> initializeSDK({
    required String userHash,
    String serverURL = "https://api.navigine.com",
  }) async {
    await _channel.invokeMethod('initialize', {
      "userHash": userHash,
      "serverUrl": serverURL,
    });
    return NavigineSDK();
  }

  loadLocation({
    required int locationId,
    Function? onSuccess,
    Function(int errorCode)? onFailed,
    Function(int state)? onUpdate,
  }) {
    _channel.invokeMethod("loadLocation", {
      "locationId": locationId,
    });
    _channel.setMethodCallHandler((call) async {
      switch (call.method) {
        case "location#onUpdate":
          onUpdate?.call(call.arguments);
          break;
        case "location#onFailed":
          onFailed?.call(call.arguments);
          break;
        case "location#onFinished":
          onSuccess?.call();
          break;
        default:
      }
    });
  }

  Future<Location> getLocation() async {
    return Location.fromMap(await _channel.invokeMethod("getLocation"));
  }

  clearSDK() {
    _channel.setMethodCallHandler(null);
  }
}
