part of navigine_sdk;

class GlobalPoint {
  double latitude = 0.0;
  double longitude = 0.0;

  GlobalPoint.fromGlobalPoint(GlobalPoint p) {
    this.latitude = p.latitude;
    this.longitude = p.longitude;
  }

  GlobalPoint.fromValue(double _lat, double _lon) {
    this.latitude = _lat;
    this.longitude = _lon;
  }

  bool isValid() {
    return (this.latitude != null) &&
        (this.longitude != null) &&
        (this.latitude).abs() <= 89.0 &&
        (this.longitude).abs() <= 180.0;
  }

  double distanceTo(GlobalPoint P) {
    if (this.isValid() && P.isValid()) {
      double lat1 = this.latitude * 3.141592653589793 / 180.0;
      double lat2 = P.latitude * 3.141592653589793 / 180.0;
      double dlat = (this.latitude - P.latitude) * 3.141592653589793 / 180.0;
      double dlon = (this.longitude - P.longitude) * 3.141592653589793 / 180.0;
      double a = sin(dlat / 2.0) * sin(dlat / 2.0) +
          sin(dlon / 2.0) * sin(dlon / 2.0) * cos(lat1) * cos(lat2);
      return 2.0 * atan2(sqrt(a), sqrt(1.0 - a)) * 6378137.0;
    } else {
      return 0.0 / 0.0;
    }
  }
}
