part of navigine_sdk;

class Location {
  int id = 0;
  int version = 0;
  String name = "";
  String? description;
  List<SubLocation> subLocations = [];
  List<Category> categories = [];
  List<RoutePath> paths = [];
  String? mapFile;
  String? updateFile;
  String? actionsFile;

  SubLocation? getSubLocationById(int id) {
    return subLocations.firstWhereOrNull((sl) => sl.id == id);
  }

  static Location fromMap(var data) {
    Location l = Location();
    l.id = data["id"];
    l.version = data["version"];
    l.name = data["name"];
    l.description = data["description"];
    l.mapFile = data["mapFile"];
    l.updateFile = data["updateFile"];
    l.actionsFile = data["actionsFile"];
    l.subLocations = data["subLocations"]
        .map<SubLocation>((sl) => SubLocation.fromMap(sl))
        .toList();

    l.categories = (data["categories"] ?? [])
        .map<Category>((sl) => Category.fromMap(sl))
        .toList();

    return l;
  }

  static Location fromAPIMap(var data) {
    return Location()
      ..name = data["title"]
      ..description = data["description"]
      ..id = data["id"];
  }
}
